<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Multi-way Branch Instructions</TITLE>
<link href="suif1_38.html" rel=Next>
<link href="suif1_36.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_36.html">previous</A>, <A HREF="suif1_38.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC37" HREF="suif1_toc.html#TOC37">Multi-way Branch Instructions</A></H2>
<P>
<A NAME="IDX236"></A>
<A NAME="IDX237"></A>

</P>
<P>
<A NAME="IDX238"></A>
Fortran computed <CODE>goto</CODE> statements and C <CODE>switch</CODE> statements
are represented in SUIF by multi-way branch (<CODE>mbr</CODE>) instructions.
These are easier to analyze than the equivalent series of conditional
branches, and they can easily be used to generate efficient jump table
code.  The <CODE>in_mbr</CODE> class holds these multi-way branch
instructions.

</P>
<P>
<A NAME="IDX239"></A>
<A NAME="IDX240"></A>
<A NAME="IDX241"></A>
<A NAME="IDX242"></A>
The <CODE>in_mbr</CODE> class contains a field with a pointer to an array of
label symbols.  The <CODE>num_labs</CODE> method returns the number of labels
in the array.  The size of the array can be changed at any time using
the <CODE>set_num_labs</CODE> method; if necessary the array will be
reallocated.  A particular element within the array can be accessed
using the <CODE>label</CODE> and <CODE>set_label</CODE> methods.  You must specify
the array index, and, as usual, the elements are numbered beginning with
zero.

</P>
<P>
<A NAME="IDX243"></A>
<A NAME="IDX244"></A>
<A NAME="IDX245"></A>
<A NAME="IDX246"></A>
<A NAME="IDX247"></A>
<A NAME="IDX248"></A>
A multi-way branch instruction transfers control to one of the target
labels depending on the value in the source operand.  This operand must
have an integer type.  It can be accessed using the <CODE>src_op</CODE> and
<CODE>set_src</CODE> methods.  The value of the source operand is combined
with an integer offset to determine the target label.  The offset can be
accessed with the <CODE>lower</CODE> and <CODE>set_lower</CODE> methods.  The offset
is subtracted from the value in the source operand and the result is
used to index into the array of target labels.  If the index is within
the range of the array, the instruction branches to the label at that
position in the array; otherwise, it branches to the default target
label.  The <CODE>default_lab</CODE> and <CODE>set_default_lab</CODE> methods access
this default label field.  The destination operand of a multi-way branch
is unused and trying to set it will cause an error.  The result type
should always be the SUIF <CODE>void</CODE> type.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_36.html">previous</A>, <A HREF="suif1_38.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
